## Script (Python) "contacfolder_edit"
##bind container=container
##bind context=context
##bind namespace=
##bind script=script
##bind state=state
##bind subpath=traverse_subpath
##parameters=id='', title=None, description='', template=''
##title=Edit content and metadata
##
if not id:
    id = context.getId()

request = context.REQUEST
all_categories = context.getCategories()

new_context = context.portal_factory.doCreate(context, id)
new_context.edit(title=title)

new_context.plone_utils.contentEdit(new_context, 
                                    id=id,
                                    description=description,
                                    template=template)

# contentEdit don't work for description as expected
new_context.setDescription(description)

# Now process with changes in the categories
for id, values in all_categories.items():
    name = request.get("name_" + id, '').strip()
    mails = [ mail.strip() for mail in request.get("mails_" + id, '').split('\n') ]
    mails = [ mail for mail in mails if mail ]
    if name and mails:
        values["name"] = name
        values["mails"] = mails
new_context.setCategories(all_categories)

return state.set(context=new_context, portal_status_message='Contact Folder changes saved.')
