#
# $Id: __init__.py 22129 2005-05-02 16:34:10Z kilobug $
#

"""ContactFolder Plone"""

__version__ = "$Revision: 22129 $" [11:-2]

## Archetypes import
from Products.Archetypes.public import *
from Products.Archetypes import listTypes
from Products.CMFCore import utils, CMFCorePermissions, DirectoryView

## App imports

import PloneContactFolder, PloneContactItem, PloneContactFolderWF, PloneContactItemWF

PROJECTNAME = 'PloneContactFolder'

product_globals = globals()

DirectoryView.registerDirectory('skins', product_globals)
DirectoryView.registerDirectory('skins/PloneContactFolder', product_globals)

## Types to register
def initialize(context):
    

    # Archetypes init
    content_types, constructors, ftis = process_types(listTypes(PROJECTNAME), PROJECTNAME)

    utils.ContentInit(
        PROJECTNAME + ' Content',
        content_types = content_types,
        permission = CMFCorePermissions.AddPortalContent,
        extra_constructors = constructors,
        fti = ftis,).initialize(context)
    
    return





